{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    {% if messages %}
        {% for message in messages %}
            <div class="alert {{ message.tags }} my-2" role="alert">
                {{message}}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>  
        {% endfor %}
    {% endif %}

    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Dashboard</li>
        </ol>
    </nav>


    <div class="testimonial-item bg-light my-4 rounded">
        <div class="rounded overflow-hidden" style="background-image: url({% static 'admin/images/back_dashboard.png' %}); object-fit: cover;">
            <div class="blog-item d-flex img-fluid">
                <div class="blog-img position-relative overflow-hidden p-3">
                    <img class="img-fluid" src="{% static 'admin/images/logo_papteng2.png' %}" alt="" style="width: 50px; height: auto;">
                </div>
                <div class="pt-3">
                    <div class="mb-0">
                        <h3 class="mb-0 text-white">Dashboard Admin</h3>
                        <h4 class="mb-0 text-white">Dinas Pendidikan & Kebudayaan Provinsi Papua Tengah</h4>
                    </div>
                </div>
            </div>
        </div>
    </div>
    
    

    <div class="testimonial-item bg-light my-4">
        <div class="blog-item bg-light rounded overflow-hidden d-flex align-items-end">
            <img src="{% static 'admin/images/backpapteng.jpg' %}" alt="Deskripsi Gambar" class="img-fluid w-100" style="max-height: 350px; object-fit: cover;object-position: top;">
        </div>
    </div>
    
    


    <div class="row mb-5">
        <div class="col-sm-12 row">
            <div class="col-md-12 col-sm-12 mb-2">
                <div class="card shadow">
                    <div class="card-header m-0 font-weight-bold text-primary">Statistik Pelayanan Pengaduan</div>
                    <div class="card-body p-3">
                        <div>
                            <canvas id="chart-perkategori"></canvas>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-12 col-sm-12 mb-2 d-none">
                <div class="card shadow">
                    <div class="card-header m-0 font-weight-bold text-primary">Statistik Pengunjung</div>
                    <div class="card-body p-3">
                        <div>
                            <canvas id="chart-tanggal"></canvas>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-6 col-sm-6 mb-2 d-none">
                <div class="card shadow">
                    <div class="card-header m-0 font-weight-bold text-primary">Browser yang Digunakan Pengunjung</div>
                    <div class="card-body p-3 d-flex justify-content-center">
                        <div class="col-md-8 col-sm-12">
                            <canvas id="chart-browser"></canvas>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-6 col-sm-6 mb-2 d-none">
                <div class="card shadow">
                    <div class="card-header m-0 font-weight-bold text-primary">Perangkat yang Digunakan Pengunjung</div>
                    <div class="card-body p-3 d-flex justify-content-center">
                        <div class="col-md-8 col-sm-12">
                            <canvas id="chart-device"></canvas>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-6 col-sm-6 mb-2">
                <div class="card shadow">
                    <div class="card-header m-0 font-weight-bold text-primary">Statistik Status Pengaduan</div>
                    <div class="card-body p-3 d-flex justify-content-center">
                        <div class="col-md-8 col-sm-12" style="min-height: 350px;">
                            <canvas id="chart-status"></canvas>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-6 col-sm-6 mb-2">
                <div class="card shadow">
                    <div class="card-header m-0 font-weight-bold text-primary">Statistik Pelayanan Pengaduan Per bulan</div>
                    <div class="card-body p-3 d-flex justify-content-center">
                        <div class="col-md-8 col-sm-12" style="min-height: 350px;">
                            <form method="get" id="filter-form">
                                <div class="col-md-12 d-flex justify-content-center px-5">
                                    <select name="year" id="year" class="form-control mx-2">
                                        {% for year in years %}
                                            <option value="{{ year }}" {% if year == selected_year %}selected{% endif %}>{{ year }}</option>
                                        {% endfor %}
                                    </select>
                                    <select name="month" id="month" class="form-control">
                                        {% for month, month_label in months_zip %}
                                            <option value="{{ month }}" {% if month == selected_month %}selected{% endif %}>{{ month_label }}</option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </form>
                            <canvas id="monthlyChartKategori"></canvas>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
    {% load static %}
    <script src="{% static 'admin/js/chart.js' %}"></script>

    <script>

        $(document).ready(function() {
            const yearSelect = $('#year');
            const monthSelect = $('#month');

            function fetchChartData() {
                const year = yearSelect.val();
                const month = monthSelect.val();

                $.ajax({
                    url: '{% url "profile:admin_datapengaduan" %}',
                    data: {
                        year: year,
                        month: month,
                    },
                    dataType: 'json',
                    success: function(data) {
                        updateChart(data.kategori_labels, data.kategori_count);
                    }
                });
            }

            function updateChart(labels, data) {
                kategoriChart.data.labels = labels;
                kategoriChart.data.datasets[0].data = data;
                kategoriChart.update();
            }

            yearSelect.on('change', fetchChartData);
            monthSelect.on('change', fetchChartData);
        });
        

        function dynamicColors() {
            var r = Math.floor(Math.random() * 255);
            var g = Math.floor(Math.random() * 255);
            var b = Math.floor(Math.random() * 255);
            return "rgba(" + r + "," + g + "," + b + ", 0.5)";
        }
        function poolColors(a) {
            var pool = [];
            for(i = 0; i < a; i++) {
                pool.push(dynamicColors());
            }
            return pool;
        }

        const pendingCount = {{ pending_count }};
        const selesaiCount = {{ selesai_count }};
        const belumSelesaiCount = {{ belum_selesai_count }};

        // Persiapan data untuk Chart.js
        const data = {
            labels: ['Pending', 'Selesai', 'Belum Selesai'],
            datasets: [{
                label: 'Status Pengaduan',
                data: [pendingCount, selesaiCount, belumSelesaiCount],
                backgroundColor: [
                    'rgba(255, 99, 132, 0.5)', // Pending - Merah
                    'rgba(54, 162, 235, 0.5)', // Selesai - Biru
                    'rgba(255, 206, 86, 0.5)', // Belum Selesai - Kuning
                ],
                borderColor: [
                    'rgba(255, 99, 132, 1)',
                    'rgba(54, 162, 235, 1)',
                    'rgba(255, 206, 86, 1)',
                ],
                borderWidth: 1
            }]
        };

        // Konfigurasi Chart.js untuk pie chart
        const config = {
            type: 'pie',
            data: data,
            options: {
                responsive: true,
                plugins: {
                    legend: {
                        position: 'top',
                    },
                    tooltip: {
                        callbacks: {
                            label: function(tooltipItem) {
                                return tooltipItem.label + ': ' + tooltipItem.raw.toFixed(0);
                            }
                        }
                    }
                }
            }
        };

        // Inisialisasi Chart.js
        const pieChart = new Chart(
            document.getElementById('chart-status'),
            config
        );

        const chartPerkategori = {{ chart_labels|safe }};
        const chartDatasets = {{ chart_datasets|safe }};

        // Persiapan data untuk Chart.js
        const data_perkategori = {
            labels: chartPerkategori,
            datasets: chartDatasets.map(dataset => ({
                label: dataset.label,
                data: dataset.data,
                backgroundColor: dynamicColors(), // Generate random color for each bar
                borderColor: 'rgba(0, 0, 0, 0.2)', // Border color for each bar
                borderWidth: 0, 
            }))
        };

        const configPerkategori = {
            type: 'bar',
            data: data_perkategori,
            options: {
                indexAxis: 'y', 
                responsive: true,
                plugins: {
                    legend: {
                        display: true,
                        position: 'top',
                    },
                    tooltip: {
                        mode: 'index',
                        intersect: false,
                    }
                },
                scales: {
                    x: {
                        stacked: false, // Disable stacking on x-axis
                    },
                    y: {
                        stacked: false, // Disable stacking on y-axis
                    }
                }
            },
        };

        // Inisialisasi Chart.js
        const _chartPerkategori = new Chart(
            document.getElementById('chart-perkategori'),
            configPerkategori
        );
        
        const chartTanggal = {{date_labels|safe}};
        const data_tanggal = {
            labels: chartTanggal,
            datasets: [
                {   
                    label: 'Statistik Pengunjung',
                    backgroundColor: poolColors(chartTanggal.length),
                    borderColor: 'rgb(32, 201, 151)',
                    data: {{date_count|safe}},
                },
            ]
        };
        const configTanggal = {
            type: 'line',
            data: data_tanggal,
            options: {
                indexAxis: 'x',
                responsive: true,
            }
        };
        const _chartTanggal = new Chart(
            document.getElementById('chart-tanggal'),
            configTanggal
        );

        const chartBrowser = {{browser_labels|safe}};
        const data_browser = {
            labels: chartBrowser,
            datasets: [
                {   
                    label: 'Statistik Browser',
                    backgroundColor: poolColors(chartBrowser.length),
                    data: {{browser_count|safe}},
                },
            ]
        };
        const configBrowser = {
            type: 'pie',
            data: data_browser,
            options: {
                indexAxis: 'x',
                responsive: true,
            }
        };
        const _chartBrowser = new Chart(
            document.getElementById('chart-browser'),
            configBrowser
        );

        const chartDevice = {{device_labels|safe}};
        const data_device = {
            labels: chartDevice,
            datasets: [
                {   
                    label: 'Statistik Device',
                    backgroundColor: poolColors(chartDevice.length),
                    data: {{device_count|safe}},
                },
            ]
        };
        const config_device = {
            type: 'pie',
            data: data_device,
            options: {
                indexAxis: 'x',
                responsive: true,
            }
        };
        const _chartDevice = new Chart(
            document.getElementById('chart-device'),
            config_device
        );

        // Chart Kategori
        const chartKategori = {{ kategori_labels|safe }};
        const dataKategori = {
            labels: chartKategori,
            datasets: [{
                label: 'Data per Kategori',
                backgroundColor: poolColors(chartKategori.length),
                borderColor: 'rgb(54, 162, 235)',
                data: {{ kategori_count|safe }},
            }],
        };

        const configKategori = {
            type: 'doughnut',
            data: dataKategori,
            options: {
                responsive: true,
                plugins: {
                    tooltip: {
                        callbacks: {
                            label: function(context) {
                                let label = context.label || '';
                                if (label) {
                                    label += ': ';
                                }
                                label += context.raw.toLocaleString();
                                return label;
                            }
                        }
                    }
                }
            },
            elements: {
                arc: {
                    borderRadius: 10
                }
            },
        };

        const kategoriChart = new Chart(
            document.getElementById('monthlyChartKategori'),
            configKategori
        );

        
    </script>
    
{% endblock scripts_bawah %}